import type { FindSocials, FindSocialsVariables } from 'types/graphql'

import type {
  CellSuccessProps,
  CellFailureProps,
  TypedDocumentNode,
} from '@redwoodjs/web'

import CellEmpty from 'src/components/Cell/CellEmpty/CellEmpty'
import CellFailure from 'src/components/Cell/CellFailure/CellFailure'
import CellLoading from 'src/components/Cell/CellLoading/CellLoading'
import SocialLinks from 'src/components/Social/SocialLinks/SocialLinks'

export const QUERY: TypedDocumentNode<FindSocials, FindSocialsVariables> = gql`
  query SocialsQuery {
    socials {
      id
      name
      type
      username
    }
  }
`

export const Loading = () => <CellLoading />

export const Empty = () => <CellEmpty />

export const Failure = ({ error }: CellFailureProps<FindSocials>) => (
  <CellFailure error={error} />
)

export const Success = ({ socials }: CellSuccessProps<FindSocials>) => (
  <SocialLinks socials={socials} />
)
